# coding: utf-8

"""
    Pdfless API

    Pdfless allows you to quickly and easily generate PDF documents using templates designed with HTML/CSS and conditional formatting.

    The version of the OpenAPI document: v1
    Contact: contact@pdfless.com
    Generated by OpenAPI Generator (https://openapi-generator.tech)

    Do not edit the class manually.
"""  # noqa: E501


from __future__ import annotations
import pprint
import re  # noqa: F401
import json

from datetime import datetime
from pydantic import BaseModel, ConfigDict, Field, StrictStr
from typing import Any, ClassVar, Dict, List, Optional
from typing import Optional, Set
from typing_extensions import Self

class DocumentTemplateDto(BaseModel):
    """
    DocumentTemplateDto
    """ # noqa: E501
    id: Optional[StrictStr] = Field(default=None, description="Template identifier")
    name: Optional[StrictStr] = Field(default=None, description="Template name")
    image_preview_url: Optional[StrictStr] = Field(default=None, description="Image preview of document template", alias="imagePreviewUrl")
    pdf_preview_url: Optional[StrictStr] = Field(default=None, description="PDF preview of document template", alias="pdfPreviewUrl")
    created: Optional[datetime] = Field(default=None, description="Creation date")
    modified: Optional[datetime] = Field(default=None, description="Modification date")
    __properties: ClassVar[List[str]] = ["id", "name", "imagePreviewUrl", "pdfPreviewUrl", "created", "modified"]

    model_config = ConfigDict(
        populate_by_name=True,
        validate_assignment=True,
        protected_namespaces=(),
    )


    def to_str(self) -> str:
        """Returns the string representation of the model using alias"""
        return pprint.pformat(self.model_dump(by_alias=True))

    def to_json(self) -> str:
        """Returns the JSON representation of the model using alias"""
        # TODO: pydantic v2: use .model_dump_json(by_alias=True, exclude_unset=True) instead
        return json.dumps(self.to_dict())

    @classmethod
    def from_json(cls, json_str: str) -> Optional[Self]:
        """Create an instance of DocumentTemplateDto from a JSON string"""
        return cls.from_dict(json.loads(json_str))

    def to_dict(self) -> Dict[str, Any]:
        """Return the dictionary representation of the model using alias.

        This has the following differences from calling pydantic's
        `self.model_dump(by_alias=True)`:

        * `None` is only added to the output dict for nullable fields that
          were set at model initialization. Other fields with value `None`
          are ignored.
        """
        excluded_fields: Set[str] = set([
        ])

        _dict = self.model_dump(
            by_alias=True,
            exclude=excluded_fields,
            exclude_none=True,
        )
        # set to None if name (nullable) is None
        # and model_fields_set contains the field
        if self.name is None and "name" in self.model_fields_set:
            _dict['name'] = None

        # set to None if image_preview_url (nullable) is None
        # and model_fields_set contains the field
        if self.image_preview_url is None and "image_preview_url" in self.model_fields_set:
            _dict['imagePreviewUrl'] = None

        # set to None if pdf_preview_url (nullable) is None
        # and model_fields_set contains the field
        if self.pdf_preview_url is None and "pdf_preview_url" in self.model_fields_set:
            _dict['pdfPreviewUrl'] = None

        # set to None if modified (nullable) is None
        # and model_fields_set contains the field
        if self.modified is None and "modified" in self.model_fields_set:
            _dict['modified'] = None

        return _dict

    @classmethod
    def from_dict(cls, obj: Optional[Dict[str, Any]]) -> Optional[Self]:
        """Create an instance of DocumentTemplateDto from a dict"""
        if obj is None:
            return None

        if not isinstance(obj, dict):
            return cls.model_validate(obj)

        _obj = cls.model_validate({
            "id": obj.get("id"),
            "name": obj.get("name"),
            "imagePreviewUrl": obj.get("imagePreviewUrl"),
            "pdfPreviewUrl": obj.get("pdfPreviewUrl"),
            "created": obj.get("created"),
            "modified": obj.get("modified")
        })
        return _obj


